



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++空类以及没有成员变量的类的大小</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++空类以及没有成员变量的类的大小</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 21:29:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　关于C++中空类的大小为1，我们大家都有所了解，但是除了空类之外的其他一些没有成员变量的类的大小，还是有很多不明之处的。</p>
<p>　　我们来看如下一个例子：</p>
<div>
<table>
<tbody>
<tr>
<td>
<p>#include&lt;iostream&gt;</p>
<p>using namespace std;</p>
<p>class a {};</p>
<p>class b{};</p>
<p>class c :public a{</p>
<p>virtual void fun() = 0;</p>
<p>};</p>
<p>class d :public b, public c{};</p>
<p>int main()</p>
<p>{</p>
<p>cout &lt;&lt; "sizeof(a)" &lt;&lt; sizeof(a) &lt;&lt; endl;</p>
<p>cout &lt;&lt; "sizeof(b)" &lt;&lt; sizeof(b) &lt;&lt; endl;</p>
<p>cout &lt;&lt; "sizeof(c)" &lt;&lt; sizeof(c) &lt;&lt; endl;</p>
<p>cout &lt;&lt; "sizeof(d)" &lt;&lt; sizeof(d) &lt;&lt; endl;</p>
<p>getchar();</p>
<p>return 0;</p>
<p>}</p>
</td>
</tr>
</tbody>
</table>
</div>
<p>程序执行的输出结果为：</p>
<p>sizeof(a)=1</p>
<p>sizeof(b)=1</p>
<p>sizeof(c)=4</p>
<p>sizeof(d)=8</p>
<p>　　为什么会出现这种结果呢？初学者肯定会很烦恼是吗？类a，b明明是空类，它的大小应该为为0，为什么　编译器输出的结果为1呢？这就是我们刚才所说的实例化的原因（空类同样可以被实例化），每个实例在内存中都有一个独一无二的地址，为了达到这个目的，编译器往往会给一个空类隐含的加一个字节，这样空类在实例化后在内存得到了独一无二的地址，所以a，b的大小为1。</p>
<p>　　而类c是由类a派生而来，它里面有一个纯虚函数，由于有虚函数的原因，有一个指向虚函数表的指针（vptr，有多个虚函数仍然是只有一个指针），在32位的系统分配给指针的大小为4个字节，所以最后得到c类的大小为4。</p>
<p>　　类d的大小更让初学者疑惑吧，类d是由类b，c派生而来的，它的大小应该为二者之和5，为什么却是8呢？这是因为为了提高实例在内存中的存取效率，内存中会有数据对齐，于是类的大小往往被调整到4字节的整数倍。并采取就近的法则，往大的方向取最近的倍数，就是该类的大小，所以类d的大小为8个字节（假如d由3个空类和c派生而来，仍然是8）。</p>
<p>　　当然在不同的编译器上得到的结果可能不同，但是这个实验告诉我们，不管类是否为空类，是否有成员变量，这个类在创建对象的时候都是需要分配空间的（sizeof的作用见我另外一篇博文：<a href="http://www.cnblogs.com/yanqi0124/p/3796736.html" rel="external nofollow noreferrer">http://www.cnblogs.com/yanqi0124/p/3796736.html</a>）。</p>
<p>参考地址：<a href="http://blog.csdn.net/hitblue/article/details/3726754" rel="external nofollow noreferrer">http://blog.csdn.net/hitblue/article/details/3726754</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwvnvk8.html">&lbrack;转&rsqb;深入理解JavaScript的变量作用域</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyvr7jq.html">不能在DropDownList 中选择多个项</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q72weg9.html">转载：C&num;保存文件时重名自动生成新文件的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwxmyy9.html">mysql 根据查询结果集更新</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zlnm49.html">lintcode ：二叉树的最大深度</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd30ne8.html">Android从服务端获取json解析显示在客户端上面</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x1kkz9.html">从高德 SDK 学习 Android 动态加载资源</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdj0y78.html">&lbrack;Java&rsqb;HashMap的两种排序方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde6gkv9.html">初来乍到--------smarty</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1vo4zq.html">安装Oracle JDK 7&period;0与8&period;0 for Mac OS X后Eclipse启动报错的解决之道</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdwv249.html">LigerUI一个前台框架增、删、改asp&period;net代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8melr3pq.html">c&plus;&plus;初学（电梯实验）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz37m08.html">PAT 甲级真题题解（63-120）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvdzdy8.html">c&plus;&plus;输出小数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv20gej9.html">responseHandler</a>
		</li>
						<li><a href="https://www.batexi.com/a/960y5n39.html">phpstorm连接ftp</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdy2vz9.html">php项目，别人无法访问自己&lpar;windows 系统&rpar;上Apache服务器原因&lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rnny08.html">C语言中，float在内存中的储存方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlo42z9.html">Robotium源码解读-native控件&sol;webview元素的获取和操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm2kvg9.html">设计模式之flyweight享元模式</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j0vkw0q.html">HTTP协议返回代码含义</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn602d8.html">如何安装Favicon</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v4wgn8.html">【高斯消元】BZOJ 1013&colon; &lbrack;JSOI2008&rsqb;球形空间产生器sphere</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oklnep9.html">uva 437  hdu 1069</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0dznlq.html">CodeForces 300A&Tab; Array</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnrexrq.html">hdu 1847 Good Luck in CET-4 Everybody&excl; 博弈论</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmrev49.html">php构造函数construct用法注意事项</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnre10q.html">使用IDEA自带maven建java项目时报错。</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmp1069.html">MyEclipse 启动tomcat时报错：Cannot change deployment state from ERROR to REDEPLOYING&period;ds</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmr3g79.html">Android 通过 Intent 传递类对象</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
